unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, Grids, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    DrawGrid1: TDrawGrid;
    procedure DrawGrid1CheckboxToggled(sender: TObject; aCol, aRow: Integer;
      aState: TCheckboxState);
    procedure DrawGrid1GetCheckboxState(Sender: TObject; ACol, ARow: Integer;
      var Value: TCheckboxState);
    procedure DrawGrid1SetCheckboxState(Sender: TObject; ACol, ARow: Integer;
      const Value: TCheckboxState);
    procedure FormCreate(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

var
  Checks: Array of boolean;

{ TForm1 }

procedure TForm1.DrawGrid1CheckboxToggled(sender: TObject; aCol, aRow: Integer;
  aState: TCheckboxState);
const
  YES_NO: array[boolean] of string = ('not ', '');
begin
  Caption := Format('Row %d: %schecked', [ARow, YES_NO[AState = cbChecked]]);
end;

procedure TForm1.DrawGrid1GetCheckboxState(Sender: TObject; ACol,
  ARow: Integer; var Value: TCheckboxState);
begin
  if Checks[ARow - DrawGrid1.FixedRows] then
    Value := cbChecked
  else
    Value := cbUnchecked;
end;

procedure TForm1.DrawGrid1SetCheckboxState(Sender: TObject; ACol,
  ARow: Integer; const Value: TCheckboxState);
begin
  if Value = cbChecked then
    Checks[ARow - DrawGrid1.FixedRows] := true
  else
    Checks[ARow - DrawGrid1.FixedRows] := false;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  DrawGrid1.RowCount := 10;
  SetLength(Checks, DrawGrid1.RowCount - DrawGrid1.FixedRows);
end;

end.

